<?php
    error_reporting(0);
    require(PATHSERVER.'/models/ERP/bsaleDAL.php');
    require(PATHSERVER.'/controllers/resource/xml/decodeXMLv1.php');
    
    
    class BsaleBLL extends BsaleDAL {
        private $invoiceCode = 33; private $dispatchGuideCode = 52;
        
        public function getThirdListBLL(){
            return $this->getThirdListDAL();
        }
        public function getThirdListDateBLL($year,$month){
            return $this->getThirdListDateDAL($year, $month);
        }
        public function getSalesDocumentBLL($store,$type,$year,$month){
            $info = $this->getThirdListDateBLL($year, $month);
            foreach($info as $inf){
                if($inf['codeSii'] == $this->invoiceCode || $inf['codeSii'] == $this->dispatchGuideCode){
                     $dat[] = $inf;
                     $this->putDocumentXML($inf['urlXml'],$this->defNameXMLBLL($store,$type,$inf['clientCode'],$inf['number']));
                }
            }
            $this->saveDocumentBLL($this->defNameBLL($store,$type,$year,$month), $dat);
            return $dat;
        }
        public function saveDocumentBLL($filename, $data){
            file_put_contents($filename, json_encode($data));
        }
        public function getDocumentBLL($filename){
            return json_decode(file_get_contents($filename), TRUE);
        }
        public function getDocumentXMLBLL($fileName){
            $decode = new decodeXMLv1();
            return $decode->decode($fileName);
        }
        public function defNameBLL($store,$type,$year,$month){
            return PATHSERVER.'/models/ERP/json/t-'.$type.'-str-'.$store.'-y-'.$year.'-m-'.$month.'.json';
        }
        public function defNameXMLBLL($store,$type,$supplier,$number){
            return PATHSERVER.'/models/ERP/XML/str-'.$store.'-t-'.$type.'-s-'.$supplier.'-n-'.$number.'.xml';
        }
        public function getSupplierBLL($data){
            $info = array();
            foreach($data as $dt){
                $row['supplierName'] = $dt['clientActivity'];
                $row['rut'] = $dt['clientCode'];
                if($this->cleanSupplier($info, $row['rut']) == 0){
                    $info[] = $row;
                }
            }
            return $info;
        }
        public function cleanSupplier($data,$code){
            foreach($data as $dat){
                if($dat['rut'] === $code){
                    return 1;
                }
            }
            return 0;
        }
        public function putDocumentXML($url,$filename){
            if(!empty($url)){
                $xml = file_get_contents($url); 
                file_put_contents($filename, $xml);
            }
        }
        public function postDataBLL($type,$data){
            return $this->postDataDAL($type, $data);
        }
        public function getDataBLL($type){
            return $this->getDataDAL($type);
        }
        public function getDataListBLL($type){
            return $this->getDataListDAL($type);
        }
        
    }
