<?php
    require_once('../../config.php');
    require_once(PATHSERVER.'/models/products/products.php');
    require_once(PATHSERVER.'/controllers/ERP/bsaleBLL.php');
    
    class ProductsBLL extends ProductsDAL{
        
        public function getProductCodeBLL($code){
            return $this->getProductCodeDAL($code);
        }
        public function getProductListBLL(){
            return $this->getProductListDAL();
        }
        public function getDataBLL_ERP($type){
            $ERP = new BsaleBLL();
            return $ERP->getDataBLL($type);
        }
        public function getDataListBLL_ERP($type){
            $ERP = new BsaleBLL();
            return $ERP->getDataListBLL($type);
        }
        public function setProductBLL($d){
            $ERP = new BsaleBLL();
            $resp = $ERP->postDataBLL('variantPost', $this->ERPPOST($d));
            if(!empty($resp['id'])){
                $d['sku'] = $this->makeSKU($d['typeProduct']);
                $d['date'] = date('Y-m-d');
                $d['idERP'] = $resp['id'];
                $r = $this->addProductDAL($d);
                return $r;
            }else{
                return 0;
            }
            
        }
        public function makeSKU($typeProduct){
            $configPro = $this->getConfigProductDAL();
            foreach($configPro as $pro){
                if($typeProduct == $pro['categoryID']){
                    return $pro['prefixed'].($pro['lastID']+1);
                }
            }
        }
        public function ERPPOST($data){
            return array('productId'=>$data['product'],'description'=>$data['nameProduct'],'unlimitedStock'=>1,'allowNegativeStock'=>1,'barCode'=>$data['codeBar'],'state'=>1,'prestashopCombinationId'=>'');
        }
        public function getPriceBLL($sku){
            return $this->getPriceDAL($sku);
        }
        public function updatePriceBLL($data){
            $ERP = new BsaleBLL(); $pList = 3;
            $put = array('variantValue'=>$data['bPrice'],'id'=>$data['idERP']);
//            $data['idERP'] = 470768;
            $type = '/v1/price_lists/'.$pList.'/details/'.$data['idERP'].'.json';
//            $type = '/v1/products/'.$data['idERP'];
            $r = $ERP->putDataDAL($type, $put);
            $this->updatePriceDAL($data);
            return $r;
        }
        public function getLastUniqueIDBLL($id){
            return $this->getLastUniqueIDDAL($id);
        }
        public function addUniqueProducBLL($data) {
            $this->addUniqueProductDAL($data);
        }
        public function printLabelUniqueBLL($idDocument,$idProduct){
            return $this->printLabelUniqueDAL($idDocument, $idProduct);
        }
        public function dispatchSIDBLL($data){
            return $this->dispatchSIDDAL($data);
        }
        public function sectorizarSIDBLL($data){
            return $this->sectorizarSIDDAL($data);
        }
    }
 