<?php
    require_once('../../config.php');
    require_once(PATHSERVER.'/models/bd.php'); 
    
    class ProductsDAL extends Connect{
        public function __construct() {
            parent::__construct();
        }
        
        public function getProductCodeDAL($code){
            $sql = 'SELECT * FROM products WHERE SKU="'.$code.'"';
            $result = $this->conn->query($sql);
            return mysqli_fetch_assoc($result);
        }
        public function getProductListDAL(){
            $sql = 'SELECT * FROM products"';
            $result = $this->conn->query($sql);
            while($row =  mysqli_fetch_assoc($result)){
                $info[] = $row;
            }
//            $this->conn->close();
            return $info;
        }
        public function addProductDAL($d){
            $find = $this->findProduct($d['codeBar']);
            if($find == 0){
                $sql = 'INSERT INTO products (sku,nameProduct,prefixed,brands,codeBar,idERP,createDate) VALUES("'.$d['sku'].'","'.$d['nameProduct'].'","'.$d['prefixed'].'","'.$d['brands'].'","'.$d['codeBar'].'","'.$d['idERP'].'","'.$d['date'].'")';
                $this->conn->query($sql);
                $this->updateProductConfigDAL();
                $r = 1;
            }else{
                $r = 0;
            }
            return $r;
//            $this->conn->close();
        }
        public function findProduct($codeBar){
            $sql = 'SELECT codeBar FROM products WHERE codeBar="'.$codeBar.'"';
            $result = $this->conn->query($sql); 
//            $this->conn->close();
            return $result->num_rows;
        }
        public function getConfigProductDAL(){
            $sql = 'SELECT * from productConfig';
            $result = $this->conn->query($sql);
            while($row = mysqli_fetch_assoc($result)){
                $info[] = $row;
            }
//            $this->conn->close();
            return $info;
        }
        public function updateProductConfigDAL(){
            $sql = 'UPDATE productConfig SET lastID = lastID +1';
            $this->conn->query($sql);
        }
        public function getPriceDAL($sku){
            $sql = 'SELECT lastPrice,typePrice FROM products WHERE sku="'.$sku.'"';
            $result = $this->conn->query($sql);
            $row = mysqli_fetch_assoc($result);
            return array('price'=>$row['price'],'typePrice'=>$row['typePrice']);
        }
        public function updatePriceDAL($data){
            $sql = 'UPDATE products SET lastPrice="'.$data['bPrice'].'" WHERE sku="'.$data['sku'].'"';
            $this->conn->query($sql);
            $sql = 'INSERT INTO productsPrices (sku,price,offerPrice,manualPrice,channel,effectiveDate,effectiveDateTime,manager) VALUES("'.$data['sku'].'","'.$data['bPrice'].'","'.$data['oPrice'].'","'.$data['mPrice'].'","'.$data['channel'].'","'.$data['effectiveDate'].'","'.$data['effectiveDateTime'].'","'.$data['manager'].'")';
            $this->conn->query($sql);
        }
        public function getLastUniqueIDDAL($id){
            $sql = 'SELECT max(correlative) as correlative FROM uniqueProducts WHERE idProduct="'.$id.'"';
            $result = $this->conn->query($sql);
            $correlative = mysqli_fetch_assoc($result)['correlative'];
            $correlative = empty($correlative) ? 1 : $correlative;
            return $correlative;
        }
        public function addUniqueProductDAL($data){
            $sql = 'INSERT INTO uniqueProducts (idProduct,superID,correlative,idDocumentIncome,dateAdd,state,cost,printLabel) VALUES ("'.$data['idProduct'].'","'.$data['superID'].'","'.$data['correlative'].'","'.$data['idDocumentIncome'].'","'.$data['dateAdd'].'","'.$data['state'].'","'.$data['cost'].'","'.$data['print'].'")';
            $this->conn->query($sql);
        }
        public function printLabelUniqueDAL($idDocument,$idProduct){
            $sql = 'SELECT idProduct FROM uniqueProducts WHERE idProduct="'.$idProduct.'" AND idDocumentIncome="'.$idDocument.'"';
            $result = $this->conn->query($sql);
            $row = mysqli_fetch_assoc($result)['idProduct'];
            return $row;
        }
        public function dispatchSIDDAL($data){
            $sql = 'UPDATE uniqueProducts SET location = 328,observation="Salida: '.$this->getNameDocument($data['typeDocument']).' | Empresa: '.$this->getNameCompany($data['company']).'",typeDocOut="'.$data['typeDocument'].'",nDocOut="'.$data['nDocument'].'",dateLastInventory="'.date('Y-m-d H:i:s').'",state = 1,nCompany="'.$data['company'].'" WHERE superID="'.$data['sid'].'"';
            $result = $this->conn->query($sql);
            return array('rows'=>$this->conn->affected_rows,'sql'=>'');
        }
        private function getNameDocument($typeDoc){
            switch ($typeDoc){
                case 1: $tDoc = 'Factura'; break;
                case 2: $tDoc = 'Guia Despacho'; break;
                case 3: $tDoc = 'Borrador'; break;
            }
            return $tDoc;
        }
         private function getNameCompany($idCompany){
            switch ($idCompany){
                case 1: $nComp = 'Emmett'; break;
                case 2: $nComp = 'SoundStore'; break;
                case 3: $nComp = 'Groben'; break;
            }
            return $nComp;
        }
         public function sectorizarSIDDAL($data){
            $sql = 'UPDATE uniqueProducts SET locationName = "'.$data['sector'].'",dateLastInventory="'.date('Y-m-d H:i:s').'",observation="Ordenado en: '.$data['sector'].'" WHERE superID="'.$data['sid'].'"';
            $result = $this->conn->query($sql);
            return array('rows'=>$this->conn->affected_rows,'sql'=>$sql);
        }
    }

