<?php
    require_once('../../config.php'); 
    include(PATHSERVER.'/controllers/products/products.php');
    include(PATHSERVER.'/controllers/invoices/invoices.php');
    
    $products = new ProductsBLL();
    $invoice = new InvoicesBLL();
    $invoiceInfo = $invoice->getInvoiceIdBLL($_POST['id']);
    $fileJson = $invoiceInfo['urlJson'];
    $filename = PATHSERVER.$fileJson;
    $data = json_decode(file_get_contents($filename),TRUE);
    
    echo json_encode(array('data'=>format($data,$products)));
    
    function format($data,$products){
        $details = $data['details']; $x = 0;
        foreach($details as $det){
            $infoProduct = $products->getProductCodeBLL($det['sku']);
            $row['item'] = $x + 1;
            $row['idERP'] = $det['idERP'];
            $row['sku'] = $det['sku'];
            $row['productName'] = $infoProduct['prefixed'].' '.$infoProduct['nameProduct'];
            $row['qty'] = $det['qty'];
            $row['cost'] = nf($det['cost']);
            $row['costDcto'] = nf($det['costDcto']);
            $row['costTeoric'] = $infoProduct['lastCost'];
            $row['stock'] = $stock;
            $row['lastCost'] = $stock;
            $row['pricePonderateAvg'] = $pricePonderateAvg;
            $row['total'] = nf($det['qty'] * $det['cost']);
            $row['logPrice'] = $logPrice;
            $row['mainPrice'] = '<input type="number" class="form-control fInvoice" idERP="'.$det['idERP'].'" sku="'.$det['sku'].'" id="bPrice_'.$x.'"  onChange="changePrice(`'.$x.'`,`'.$det['idERP'].'`,`'.$det['sku'].'`,`1`);" type="1" placeholder="Precio Base" value="'.$infoProduct['lastPrice'].'">';
            $row['offerPrice'] = '<input type="number" class="form-control fInvoice" idERP="'.$det['idERP'].'" sku="'.$det['sku'].'" id="oPrice_'.$x.'" onChange="changePrice(`'.$x.'`,`'.$det['idERP'].'`,`'.$det['sku'].'`,`2`);" type="2" placeholder="Precio Oferta">';
            $row['manualPrice'] = '<input type="number" class="form-control fInvoice"idERP="'.$det['idERP'].'" sku="'.$det['sku'].'" id="mPrice_'.$x.'" onChange="changePrice(`'.$x.'`,`'.$det['idERP'].'`,`'.$det['sku'].'`,`3`);" type="3" placeholder="Precio Manual">';
            $row['goToWeb'] = $goToWeb;
            $row['requestPublish'] = $requestPublish;
            $info[] = $row; $x++;
        }
        return $info;
    }
?>
