<?php
 require_once('../../config.php');
 include(PATHSERVER.'/controllers/ERP/bsaleBLL.php');
 include('invoices.php');
 $bsale = new BsaleBLL();
 $invoice = new InvoicesBLL();
 $data = formatPOST(getJSON($invoice, $_POST['id']));
 $resp = $bsale->postDataBLL('receptionPost',$data);
 echo json_encode(array('data'=>$resp));
 
 function formatPOST($d){
       $details = dateStructure($d); $officeId = 1; $docType = typeDoc($d['headers']['typeDocument']); $d['headers']['observation'] = $d['headers']['supplierName'].' | '.$d['headers']['supplier'].' | Obs: '.$d['headers']['observation'];
       $headers = array('document'=>$docType,'officeId'=>$officeId,'documentNumber'=>$d['headers']['nDocument'],'note'=>$d['headers']['observation'],'details'=>$details);
       return $headers;
 }
 function dateStructure($data){
    foreach($data['details'] as $dat){
        $row['quantity'] = $dat['qty'];
        $row['code'] = $dat['sku'];
        $row['serialNumber'] = $dat['codeBar'];
        $row['cost'] = $dat['cost'];
        $row['variantid'] = $dat['idERP'];
        $info[] = $row;
    }
    return $info;
}
function getJSON($invoice, $id){
    $url = PATHSERVER.$invoice->getJsonPurchaseBLL($id);
    $data = json_decode(file_get_contents($url), TRUE);
    return $data;
}
    
    