<?php
function updateProductPrice($productId, $newPrice) {
    // La URL base de la API de Bsale
    $apiUrl = 'https://api.bsale.cl/v1/products/' . $productId;
    
    // Token de acceso
    $accessToken = '1b7908fa44b56ba04a3459db5bb6e9b12bb9fadc'; // Reemplaza con tu token de acceso

    // Datos a enviar
    $data = [
        'price' => $newPrice
    ];

    // Inicializar cURL
    $ch = curl_init($apiUrl);

    // Configuración de cURL
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "PATCH");
    curl_setopt($ch, CURLOPT_HTTPHEADER, [
        'Content-Type: application/json',
        'access_token: ' . $accessToken
    ]);
    curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($data));

    // Ejecutar la solicitud
    $response = curl_exec($ch);
    $httpCode = curl_getinfo($ch, CURLINFO_HTTP_CODE);

    // Cerrar cURL
    curl_close($ch);

    // Comprobar respuesta
    if ($httpCode == 200) {
        echo "Precio actualizado exitosamente.";
    } else {
        echo "Error al actualizar el precio: " . $response;
    }
}

// Ejemplo de uso
updateProductPrice(139336, 999999); // Reemplaza con el ID del producto y el nuevo precio
?>
