<!DOCTYPE html>
<html lang="en">
<head>
<meta charset="UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>TOMAR FOTO DE FACTURA</title>
<link href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css" rel="stylesheet">
<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap-icons@1.11.3/font/bootstrap-icons.min.css">

</head>
<body class="max-vh-50">
    <div id="resumePhoto"></div>
    <div class="container text-center ">
        <input type="hidden" id="rut" value="<?php echo $_GET['rut']; ?>">
        <input type="hidden" id="type" value="<?php echo $_GET['type']; ?>">
        <input type="hidden" id="number" value="<?php echo $_GET['number']; ?>">
  <div class="row align-items-start">
    <div class="col fs-3" style="color: whitesmoke;">
        <?php echo 'PROVEEDOR: '.$_GET['rut']; ?>
    </div>
   <div class="col fs-3" style="color: whitesmoke;">
        <?php echo 'DOCUMENTO: '.$_GET['type'] ?>
    </div>
    <div class="col fs-3" style="color: whitesmoke;">
        <?php echo 'FOLIO: '.$_GET['number'] ?>
    </div>
  </div>
</div>
<div class="container-xxl">
    <div class='ripple-background'>
      <div class='circle xxlarge shade1'></div>
      <div class='circle xlarge shade2'></div>
      <div class='circle large shade3'></div>
      <div class='circle mediun shade4'></div>
      <div class='circle small shade5'></div>
    </div>
    <div class="row">
        <div class="col-12 center">
            <label id="uploadPhoto" for="imgFile" class="form-label boton5"> <i style="font-size:75px; margin:0 auto; " class="bi bi-cloud-arrow-up"></i></label>
            <input class="form-control inPu" type="file" id="imgFile" hidden>
        </div>
    </div>
</div>

<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/popper.js/1.16.0/umd/popper.min.js"></script>
<script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
<script src="https://cdn.jsdelivr.net/npm/sweetalert2@11"></script>
<script src="myapp/js/agregar-foto.js"></script>

<style>
    body{
  background:#004085
    }


.circle{
  position: absolute;
  border-radius: 50%;
  background: white;
  animation: ripple 15s infinite;
  box-shadow: 0px 0px 1px 0px #508fb9;
}

.small{
  width: 200px;
  height: 200px;
  left: -100px;
  bottom: -100px;
}

.medium{
  width: 400px;
  height: 400px;
  left: -200px;
  bottom: -200px;
}

.large{
  width: 600px;
  height: 600px;
  left: -300px;
  bottom: -300px;
}

.xlarge{
  width: 800px;
  height: 800px;
  left: -400px;
  bottom: -400px;
}

.xxlarge{
  width: 1000px;
  height: 1000px;
  left: -500px;
  bottom: -500px;
}

.shade1{
  opacity: 0.2;
}
.shade2{
  opacity: 0.5;
}

.shade3{
  opacity: 0.7;
}

.shade4{
  opacity: 0.8;
}

.shade5{
  opacity: 0.9;
}

@keyframes ripple{
  0%{
    transform: scale(0.8);
  }
  
  50%{
    transform: scale(1.2);
  }
  
  100%{
    transform: scale(0.8);
  }
}

    .center {
        display: flex;
        justify-content: center;
        align-items: center;
        height: 100vh;
    }
    .uploadPhoto {
            background-color: indigo;
            color: white;
            padding: 0.5rem;
            font-family: sans-serif;
            border-radius: 0.3rem;
            cursor: pointer;
            margin-top: 1rem;
            text-align:center;
            font-weight:bold;
        }


.boton5 {
    color: #fff !important;
    font-size: 20px;
    font-weight: 500;
    padding: 0.5em 1.2em;
    background: #007bff;
    position: relative;
    border: 2px solid #004085;
    outline: 1px solid;
    outline-color: rgba(49, 138, 172, 0.4);
    transition: all 1s cubic-bezier(0.19, 1, 0.22, 1);
    border-radius: 150px;
}
.boton5:hover {
  box-shadow: inset 0 0 20px rgba(49, 138, 172, 0.5), 0 0 20px rgba(49, 138, 172, 0.4);
  outline-color: rgba(49, 138, 172, 0);
  outline-offset: 80px;
  text-shadow: 1px 1px 6px #fff;
}

</style>
</body>
</html>
