$('#sidProduct').on('change',function(){
    var sid = $(this).val();
    var nDocument = $('#nDocument').val();
    var company = $('#cbCompany').val();
    var typeDocument = $('#cbTypeDocument').val();
      Swal.fire({
            title: '¿Seguro que deseas despachar este producto?',
            text: "Esta acción no se puede deshacer",
            icon: 'warning',
            showCancelButton: true,
            confirmButtonText: 'SI Seguro!',
            cancelButtonText: 'No'
        }).then((result) => {
            if (result.isConfirmed) {
                $.ajax({
                    url:'../controllers/products/dispatch.php',
                    type:'POST',
                    data:{ sid: sid, nDocument:nDocument, company:company, typeDocument:typeDocument },
                    success:function(data,textStatus,jqXHR){
                        var data = jQuery.parseJSON(data);
                        console.log(data.rows);
                        if(parseInt(data.rows) > 0){
                            var title = 'Descontado'; var icon = 'success';
                        }
                        if(parseInt(data.rows) == 0){
                            var title = 'No se hizo modificacion'; var icon = 'error';
                        }
                        toast(title,icon)
                    },
                    error:function(jqXHR,textStatus, errorThrown){
                        
                    }
                })
            } else if (result.dismiss === Swal.DismissReason.cancel) {

            }
        });
});

function toast(title,icon){
    const Toast = Swal.mixin({
  toast: true,
  position: "top-end",
  showConfirmButton: false,
  timer: 3000,
  timerProgressBar: true,
  didOpen: (toast) => {
    toast.onmouseenter = Swal.stopTimer;
    toast.onmouseleave = Swal.resumeTimer;
    }
  });
  Toast.fire({
    icon: icon,
    title: title
  });
}