$(document).ready(function() {
   $('#tbListReception').DataTable({
       ajax: '../controllers/invoices/list-invoice.php',
       columns :[
           { data: 'item'},
           { data: 'typeDocument'},
           { data: 'folio'},
           { data: 'supplier'},
           { data: 'supplierName'}, 
           { data: 'subtotal'},
           { data: 'status'},
           { data: 'dateAdd'}, 
           { data: 'btnAction'}
       ],
       pageLength: 25,
       responsive: true,
       paging: false,
       searching: true,
       ordering: true,
       info: false,
       lengthChange: false,
       autoWidth: false
   });
   
}); 

function dismissInvoice(id){
    $.ajax({
        url: '../controllers/invoices/dismiss-invoice.php',
        type: 'POST',
        data: {id:id},
        success:function(data,textStatus,jqXHR){
            let d = $('#tbListReception').DataTable();
            d.ajax.reload();
        }
    })
}

function goToInvoice(id){
    let url = 'procesar-recepcion.phtml?id='+id;
    window.open(url, '_blank');

}