<?php
$toDay = strtotime(date('Y-m-d H:i:s'));
$expiredDate = strtotime(((new DateTime())->modify('+ 1 month'))->format('Y-m-d'));

$header = '{
  "documentTypeId": 23,
  "officeId": 1,
  "priceListId": 1,
  "emissionDate": '.$toDay.',
  "expirationDate":'.$expiredDate.',
  "declareSii": 0
}';

$client = '{
    "code": "77289431-7",
    "city": "Las Condes",
    "company": "Inversiones Linknew SPA",
    "municipality": "Las Condes",
    "activity": "Compra Venta de articulos para el hogar, cotillon y menaje",
    "address": "Av Padre Hurtado SUR 875, Local 1004",
    "email": "yeniffer.nunez@newtree.cl",
    "companyOrPerson": 1
}';

$details = '
 [
  {
    "comment": "Juguete para mascotas con pelota de masaje estampada con luz 7,5 cm",
    "netUnitValue": 241,
    "quantity": 360,
    "taxId": 1
  },
  {
    "comment": "182 retractor monocromático para mascotas 3m",
    "netUnitValue": 557,
    "quantity": 432,
    "taxId": 1
  },
  {
    "comment": "182 Tractor para mascotas monocromo 5m",
    "netUnitValue": 660,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "Peine pequeño para mascotas con mango de goma bicolor, aguja fina, 9x17cm",
    "netUnitValue": 439,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "Aguja fina mango de madera mediana con cuentas cepillo para mascotas 6*20cm",
    "netUnitValue": 348,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "WPS036 Bola de pelo grande, borla, pluma, palo para gato, juguete, 60cm",
    "netUnitValue": 887,
    "quantity": 300,
    "taxId": 1
  },
  {
    "comment": "Cepillo de baño de plástico para mascotas 12cm",
    "netUnitValue": 213,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "WPS160 cubo de sisal juguetes lavados 16*20*40cm",
    "netUnitValue": 2077,
    "quantity": 72,
    "taxId": 1
  },
  {
    "comment": "WPS235 tabla rascadora para gatos con disco de resorte recto 15*26cm",
    "netUnitValue": 541,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "WPS275 Juguete para mascota ratón con anillo de acero 6,5 cm",
    "netUnitValue": 189,
    "quantity": 360,
    "taxId": 1
  },
  {
    "comment": "WPS287 plato de juego bunker juguete para mascotas 25,5*36cm",
    "netUnitValue": 1624,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas bola de cuerda de algodón y lino 7,5 cm",
    "netUnitValue": 294,
    "quantity": 360,
    "taxId": 1
  },
  {
    "comment": "Juguete mascota pelota de goma mediana de colores 7,5cm",
    "netUnitValue": 257,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "WPS146 Rascador para gatos con bandeja de sisal para ratón, 15x23cm",
    "netUnitValue": 710,
    "quantity": 120,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas de fútbol con luz 6,5 cm.",
    "netUnitValue": 222,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas bola de espina larga con luz 7,5 cm",
    "netUnitValue": 231,
    "quantity": 360,
    "taxId": 1
  },
  {
    "comment": "Pelota redonda de sisal con juguete de plumas para mascotas 6*6cm",
    "netUnitValue": 287,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Guantes de aseo para mascotas 24,5 cm * 18 cm",
    "netUnitValue": 366,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas con cuerda de cáñamo, bola redonda de goma, 18cm",
    "netUnitValue": 426,
    "quantity": 192,
    "taxId": 1
  },
  {
    "comment": "Juguete mascota bola oreja gemela 22cm",
    "netUnitValue": 401,
    "quantity": 360,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas rugby con luz 5*10cm",
    "netUnitValue": 287,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas Pet Circle con luz 12cm",
    "netUnitValue": 450,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas con palo de dentición con aro luminoso 6,5*12cm",
    "netUnitValue": 255,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "波浪纹宠物牵引绳1.5*120cm",
    "netUnitValue": 353,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "Correa para mascotas con patrón de ondas 2,0*120 cm",
    "netUnitValue": 439,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "Correa para mascotas con patrón de ondas 2,5*120 cm",
    "netUnitValue": 536,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "Varilla de plástico colgante redondo cola de pluma gato divertido palo juguete 45cm",
    "netUnitValue": 278,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "WPS107 Juguete Palo para Gato con Cuerda de Papel 40 cm",
    "netUnitValue": 198,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Juguete para mascotas con mordedura grande TPR de 14 cm",
    "netUnitValue": 273,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "WPS143 cuerda de cáñamo juguete para mascotas bola tricolor 4,2 cm",
    "netUnitValue": 345,
    "quantity": 360,
    "taxId": 1
  },
  {
    "comment": "Juguete mascota bola arcoíris con luz 7,5cm",
    "netUnitValue": 270,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "Impresora térmica de recibos XP-C260K",
    "netUnitValue": 43008,
    "quantity": 8,
    "taxId": 1
  },
  {
    "comment": "Cerradura de gancho rojo 6mm",
    "netUnitValue": 39,
    "quantity": 500,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico brillante clásico YY8108 3*5",
    "netUnitValue": 201,
    "quantity": 1440,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico brillante clásico YY8108 4*6",
    "netUnitValue": 218,
    "quantity": 960,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico brillante clásico YY8108 5*7",
    "netUnitValue": 276,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico brillante clásico YY8108 6*8",
    "netUnitValue": 320,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico brillante clásico YY8108 8,5*11",
    "netUnitValue": 472,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "YY8108 marco de fotos clásico de plástico brillante A4",
    "netUnitValue": 479,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico brillante clásico YY8108 9*12",
    "netUnitValue": 531,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico brillante clásico YY8108 11*14",
    "netUnitValue": 663,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "YY8195-1 marco de fotos de plástico a cuadros retro 3*5",
    "netUnitValue": 284,
    "quantity": 1440,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico a cuadros retro YY8195-1 4*6",
    "netUnitValue": 255,
    "quantity": 960,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico a cuadros retro YY8195-1 5*7",
    "netUnitValue": 309,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "YY8195-1 marco de fotos de plástico a cuadros retro 6*8",
    "netUnitValue": 351,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "YY8195-1 marco de fotos de plástico a cuadros retro 8*10",
    "netUnitValue": 477,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico a cuadros retro YY8195-1 8,5*11",
    "netUnitValue": 507,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "YY8195-1 Marco de fotos de plástico a cuadros retro A4",
    "netUnitValue": 529,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico a rayas retro YY9107 4*6",
    "netUnitValue": 284,
    "quantity": 960,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico a rayas retro YY9107 5*7",
    "netUnitValue": 340,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico a rayas retro YY9107 6*8",
    "netUnitValue": 386,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos de plástico a rayas retro YY9107 8,5*11",
    "netUnitValue": 564,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Peluche almohada cilíndrica rayas 65cm",
    "netUnitValue": 2264,
    "quantity": 100,
    "taxId": 1
  },
  {
    "comment": "Peluche almohada cilíndrica rayas 95cm",
    "netUnitValue": 4313,
    "quantity": 60,
    "taxId": 1
  },
  {
    "comment": "Peluche almohada cilíndrica rayas 115cm",
    "netUnitValue": 5404,
    "quantity": 30,
    "taxId": 1
  },
  {
    "comment": "Peluche aguacate 35cm",
    "netUnitValue": 918,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Peluche aguacate 45cm",
    "netUnitValue": 1506,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "Peluche almohada aguacate largo 50cm",
    "netUnitValue": 1435,
    "quantity": 120,
    "taxId": 1
  },
  {
    "comment": "Peluche almohada aguacate largo 90cm",
    "netUnitValue": 3732,
    "quantity": 120,
    "taxId": 1
  },
  {
    "comment": "Peluche almohada girasol 70cm",
    "netUnitValue": 2171,
    "quantity": 100,
    "taxId": 1
  },
  {
    "comment": "3 bolsas para excrementos de mascotas de colores mezclados, 21 x 29 cm.",
    "netUnitValue": 130,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "6 bolsas para excrementos de mascotas de colores mezclados 21*29 cm",
    "netUnitValue": 235,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "10 Uds. Bolsa para excrementos de mascotas de colores mezclados 21*29cm",
    "netUnitValue": 403,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Bolsa para excrementos de mascotas con huella de 3 piezas 21 * 29 cm",
    "netUnitValue": 142,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "Bolsa para excrementos de mascotas con huella de 6 piezas 21 * 29 cm",
    "netUnitValue": 258,
    "quantity": 720,
    "taxId": 1
  },
  {
    "comment": "Bolsa para excrementos de mascotas con huella de 10 piezas 21 * 29 cm",
    "netUnitValue": 445,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Juego de caja de basura de hueso de 3 piezas 21 * 29 cm",
    "netUnitValue": 199,
    "quantity": 480,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado verde de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado marrón de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado Peugeot de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado azul de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con huella de hueso de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Conjunto de nido para mascotas con estampado lindo de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado de doble patrón de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado de huella de color de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado de pintura de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Juego de nido para mascotas con estampado de camuflaje de poliéster de 10 piezas",
    "netUnitValue": 11113,
    "quantity": 24,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas pequeña estampada azul 45*60cm",
    "netUnitValue": 1113,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla esponja mascota estampada azul medio 50*65cm",
    "netUnitValue": 1394,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas grande estampada azul 55*70cm",
    "netUnitValue": 1630,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas pequeña de hueso negro 45*60cm",
    "netUnitValue": 1113,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas hueso negro mediano 50*65cm",
    "netUnitValue": 1394,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas hueso negro mediano 50*65cm",
    "netUnitValue": 1630,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con huella colorida pequeña 45*60cm",
    "netUnitValue": 1113,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con huella de color medio 50*65cm",
    "netUnitValue": 1394,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con huella de color grande 55*70cm",
    "netUnitValue": 1630,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con estampado de cabeza de mascota pequeña 45*60cm",
    "netUnitValue": 1113,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con estampado de cabeza de mascota mediana 50*65 cm",
    "netUnitValue": 1394,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con estampado de cabeza de mascota grande 55*70cm",
    "netUnitValue": 1630,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con estampado de amor amarillo pequeño 45*60cm",
    "netUnitValue": 1113,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con estampado de amor amarillo medio 50*65cm",
    "netUnitValue": 1394,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "Almohadilla de esponja para mascotas con estampado de amor amarillo grande 55*70cm",
    "netUnitValue": 1630,
    "quantity": 50,
    "taxId": 1
  },
  {
    "comment": "10 Uds. Almohadilla para pañales para mascotas 45*60cm",
    "netUnitValue": 611,
    "quantity": 420,
    "taxId": 1
  },
  {
    "comment": "10 Uds. Almohadilla para pañales para mascotas 60*60cm",
    "netUnitValue": 761,
    "quantity": 384,
    "taxId": 1
  },
  {
    "comment": "10 Uds. Almohadilla para pañales para mascotas 60*90cm",
    "netUnitValue": 1215,
    "quantity": 300,
    "taxId": 1
  },
  {
    "comment": "20 piezas almohadilla para pañales para mascotas 60*90cm",
    "netUnitValue": 2368,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "FH703 marco de fotos negro geométrico 4*4",
    "netUnitValue": 1215,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "FH703 marco de fotos negro geométrico 4*6",
    "netUnitValue": 1499,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "FH703 marco de fotos negro geométrico 5*7",
    "netUnitValue": 1703,
    "quantity": 160,
    "taxId": 1
  },
  {
    "comment": "FH703 marco de fotos negro geométrico 6*8",
    "netUnitValue": 2141,
    "quantity": 120,
    "taxId": 1
  },
  {
    "comment": "FH705 marco de fotos dorado geométrico 4*4",
    "netUnitValue": 1455,
    "quantity": 192,
    "taxId": 1
  },
  {
    "comment": "FH705 marco de fotos dorado geométrico 4*6",
    "netUnitValue": 1701,
    "quantity": 216,
    "taxId": 1
  },
  {
    "comment": "FH705 marco de fotos dorado geométrico 5*7",
    "netUnitValue": 1908,
    "quantity": 192,
    "taxId": 1
  },
  {
    "comment": "FH705 marco de fotos dorado geométrico 6*8",
    "netUnitValue": 2449,
    "quantity": 120,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos negro tipo FH704U 4*4",
    "netUnitValue": 828,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos negro tipo FH704U 4*6",
    "netUnitValue": 1026,
    "quantity": 96,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos negro tipo FH704U 5*7",
    "netUnitValue": 1147,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos negro tipo FH704U 6*8",
    "netUnitValue": 1408,
    "quantity": 128,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos dorado tipo FH706U 4*4",
    "netUnitValue": 930,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos dorado tipo FH706U 4*6",
    "netUnitValue": 1180,
    "quantity": 96,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos dorado tipo FH706U 5*7",
    "netUnitValue": 1335,
    "quantity": 216,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos dorado tipo FH706U 6*8",
    "netUnitValue": 1716,
    "quantity": 160,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos hueco circular FH708 4*6",
    "netUnitValue": 1152,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "FH783 Marco de fotos con corona dorada 4*6",
    "netUnitValue": 1518,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "FH783 marco de fotos corona dorada 5*7",
    "netUnitValue": 1809,
    "quantity": 216,
    "taxId": 1
  },
  {
    "comment": "FH917 marco de fotos horizontal negro 4*4",
    "netUnitValue": 971,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "FH917 marco de fotos horizontal negro 4*6",
    "netUnitValue": 1231,
    "quantity": 96,
    "taxId": 1
  },
  {
    "comment": "FH917 marco de fotos horizontal negro 5*7",
    "netUnitValue": 1490,
    "quantity": 216,
    "taxId": 1
  },
  {
    "comment": "FH917 marco de fotos horizontal negro 6*8",
    "netUnitValue": 1797,
    "quantity": 160,
    "taxId": 1
  },
  {
    "comment": "FH918 marco de fotos dorado horizontal 4*4",
    "netUnitValue": 879,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "FH918 marco de fotos dorado horizontal 4*6",
    "netUnitValue": 1077,
    "quantity": 96,
    "taxId": 1
  },
  {
    "comment": "FH918 marco de fotos dorado horizontal 5*7",
    "netUnitValue": 1229,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "FH918 marco de fotos dorado horizontal 6*8",
    "netUnitValue": 1490,
    "quantity": 128,
    "taxId": 1
  },
  {
    "comment": "FH723 marco de fotos negro de doble página 4*6",
    "netUnitValue": 1829,
    "quantity": 128,
    "taxId": 1
  },
  {
    "comment": "FH723 marco de fotos negro de doble página 5*7",
    "netUnitValue": 2224,
    "quantity": 96,
    "taxId": 1
  },
  {
    "comment": "FH723 marco de fotos negro de doble página 6*8",
    "netUnitValue": 2401,
    "quantity": 80,
    "taxId": 1
  },
  {
    "comment": "FH724 marco de fotos dorado de doble página 4*4",
    "netUnitValue": 1731,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "FH724 marco de fotos dorado de doble página 4*6",
    "netUnitValue": 2100,
    "quantity": 160,
    "taxId": 1
  },
  {
    "comment": "FH724 marco de fotos dorado de doble página 5*7",
    "netUnitValue": 2585,
    "quantity": 120,
    "taxId": 1
  },
  {
    "comment": "FH724 marco de fotos dorado de doble página 6*8",
    "netUnitValue": 2822,
    "quantity": 100,
    "taxId": 1
  },
  {
    "comment": "FH001 marco de fotos cóncavo y convexo de borde estrecho 5*7",
    "netUnitValue": 822,
    "quantity": 96,
    "taxId": 1
  },
  {
    "comment": "FH001 marco de fotos cóncavo y convexo de borde estrecho 6*8",
    "netUnitValue": 1013,
    "quantity": 72,
    "taxId": 1
  },
  {
    "comment": "FH001 marco de fotos cóncavo y convexo de borde estrecho 8*10",
    "netUnitValue": 1377,
    "quantity": 48,
    "taxId": 1
  },
  {
    "comment": "FH676 marco de fotos plano de borde estrecho 4*6",
    "netUnitValue": 569,
    "quantity": 288,
    "taxId": 1
  },
  {
    "comment": "FH676 marco de fotos plano de borde estrecho 5*7",
    "netUnitValue": 698,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "FH676 marco de fotos plano de borde estrecho 6*8",
    "netUnitValue": 855,
    "quantity": 240,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos rectangular vertical FH688 4*6",
    "netUnitValue": 1631,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos rectangular vertical FH688 5*7",
    "netUnitValue": 1819,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos rectangular horizontal FH689 4*6",
    "netUnitValue": 1631,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "Marco de fotos rectangular horizontal FH689 5*7",
    "netUnitValue": 1819,
    "quantity": 144,
    "taxId": 1
  },
  {
    "comment": "Taza termo monocolor con asa 1200ml",
    "netUnitValue": 2966,
    "quantity": 300,
    "taxId": 1
  },
  {
    "comment": "Taza termo portátil monocromática 900ml.",
    "netUnitValue": 2421,
    "quantity": 200,
    "taxId": 1
  },
  {
    "comment": "Taza termo con funda de silicona 500ml",
    "netUnitValue": 2566,
    "quantity": 200,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo redonda de espadaña CD8001 0,5*60cm",
    "netUnitValue": 1885,
    "quantity": 100,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo redonda de espadaña CD8001 0,5*90cm",
    "netUnitValue": 3304,
    "quantity": 210,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo redonda de espadaña CD8001 0,5*120cm",
    "netUnitValue": 6582,
    "quantity": 180,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo redonda de espadaña CD8001 0,5*150cm",
    "netUnitValue": 10148,
    "quantity": 40,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo hueco de espadaña 0,5*60cm",
    "netUnitValue": 2269,
    "quantity": 70,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo hueco de espadaña 0,5*90cm",
    "netUnitValue": 3915,
    "quantity": 100,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo hueca de totora 0,5*120cm",
    "netUnitValue": 6603,
    "quantity": 100,
    "taxId": 1
  },
  {
    "comment": "Alfombra de suelo hueco de espadaña 0,5*150cm",
    "netUnitValue": 10299,
    "quantity": 70,
    "taxId": 1
  }
]';

$h = json_decode($header,TRUE);
$c = json_decode($client,TRUE);
$d = json_decode($details,TRUE);

$dataInvoice = infoFactura($h, $c, $d);

function infoFactura($h,$c,$d){
    return array('header'=>$h,'client'=>$c,'details'=>$d);
}

